$! $Id: vmsbuild.com,v 1.2 1994/08/26 18:53:27 mikes Exp $
$!
$! Yehavi Bourvine
$! Hebrew University of Jeruselem
$! +972-2-585684
$! YEHAVI@vms.huji.ac.il
$!
$! Please address all bugs and comments to "pine-bugs@cac.washington.edu"
$!
$! Copyright 1991-1994  University of Washington
$!
$!  Permission to use, copy, modify, and distribute this software and its
$! documentation for any purpose and without fee to the University of
$! Washington is hereby granted, provided that the above copyright notice
$! appears in all copies and that both the above copyright notice and this
$! permission notice appear in supporting documentation, and that the name
$! of the University of Washington not be used in advertising or publicity
$! pertaining to distribution of the software without specific, written
$! prior permission.  This software is made available "as is", and
$! THE UNIVERSITY OF WASHINGTON DISCLAIMS ALL WARRANTIES, EXPRESS OR IMPLIED,
$! WITH REGARD TO THIS SOFTWARE, INCLUDING WITHOUT LIMITATION ALL IMPLIED
$! WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE, AND IN
$! NO EVENT SHALL THE UNIVERSITY OF WASHINGTON BE LIABLE FOR ANY SPECIAL,
$! INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
$! LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, TORT
$! (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, ARISING OUT OF OR IN CONNECTION
$! WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
$!
$! Pine and Pico are trademarks of the University of Washington.
$! No commercial use of these trademarks may be made without prior
$! written permission of the University of Washington.
$!
$! Parameters:
$!	P1	Build OPTIONS (comma separated list)
$!		NETLIB or MULTINET	- Select tcp/ip stack support
$!		LINK-ONLY		- Skip compile stage
$!		VAXC			- Force use of VAXC
$!
$!	P2	Debug selection
$!		"DEBUG"			- Compile/Link with debugger support
$!		""			- No debugger support
$!
$ defines = "ANSI_DRIVER,ATTACHMENTS"
$
$ COPY/NOLOG OS_VMS.H OSDEP.H;
$ PURGE/NOLOG OSDEP.H
$
$! Set up for the appropriate compiler
$ CC_DEF = ""
$
$ HAVEDECC = F$SEARCH("SYS$SYSTEM:DECC$COMPILER.EXE") .NES. ""
$ HAVEVAXC = F$SEARCH("SYS$SYSTEM:VAXC.EXE") .NES. ""
$ FORCEVAXC= f$locate("VAXC",P1) .lt. f$length(P1)
$ IF HAVEDECC .AND. .NOT. FORCEVAXC
$ THEN
$	COMPILER = "DEC C"
$       if (HAVEVAXC) then $ CC_DEF = CC_DEF + "/DECC"
$	CC_DEF = CC_DEF + "/STANDARD=VAXC"
$       LINK_OPT = ""
$ ELSE
$	COMPILER = "VAX C"
$       if (HAVEDECC) then $ CC_DEF = CC_DEF + "/VAXC"
$	DEFINE SYS SYS$LIBRARY	! For the Include to not fail on VAX.
$       LINK_OPT = ",[-]VMS_LINK.OPT/OPT"
$ ENDIF
$!
$ if (P2 .eqs. "DEBUG")
$   then
$      CC_DEF = CC_DEF + "/DEBUG/NOOPTIMIZE"
$      LINK   = "LINK /DEBUG"
$   else
$      CC_DEF = CC_DEF + "/NOOPTIMIZE"	! Because of compiler bugs !
$      LINK   = "LINK"
$ ENDIF
$
$ CC_DEF = CC_DEF + "/DEFINE=(''defines')"
$
$ if f$locate("LINK-ONLY", P1) .LT. f$length(P1) then $ goto LINK
$
$ write sys$output "%VMSBUILD-I-BUILD, Building PICO using ", COMPILER
$ SET VERIFY
$ CC'CC_DEF' attach
$ CC'CC_DEF' ansi
$ CC'CC_DEF' basic
$ CC'CC_DEF' bind
$ CC'CC_DEF' browse
$ CC'CC_DEF' buffer
$ CC'CC_DEF' composer 
$ CC'CC_DEF' display
$ CC'CC_DEF' file 
$ CC'CC_DEF' fileio
$ CC'CC_DEF' line
$ CC'CC_DEF' pico
$ CC'CC_DEF' random 
$ CC'CC_DEF' region 
$ CC'CC_DEF' search
$ CC'CC_DEF' spell 
$ CC'CC_DEF' window 
$ CC'CC_DEF' word
$ CC'CC_DEF' main
$ CC'CC_DEF' os_VMS
$ SET NOVER
$!
$ write sys$output "%VMSBUILD-I-LIBRARY, Creating PICO library"
$ LIBRARY/OBJECT/CREATE/INSERT PICO *.OBJ
$ PURGE/nolog PICO.OBJ
$!
$LINK:
$ write sys$output "%VMSBUILD-I-LINK, Linking stand-alone PICO editor utility"
$ LINK/EXE=PICO MAIN,PICO/LIBR'LINK_OPT'
$ PURGE/NOLOG *.OBJ
$ PURGE/NOLOG *.EXE
